<?php

namespace app\admin\controller\school\activity\order;

use app\common\controller\Backend;

/**
 * 活动订单核销管理
 *
 * @icon fa fa-circle-o
 */
class OrderCode extends Backend
{

    /**
     * OrderCode模型对象
     * @var \app\admin\model\school\activity\order\OrderCode
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\school\activity\order\OrderCode;
        $this->view->assign("statusList", $this->model->getStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;

        $this->searchFields = ["id","order.refund_error","order.refund_no","order.order_no","order.pay_no","code","miniurl","user.nickname","user.realname","user.mobile"];


        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['order','user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('order')->visible(['order_no']);
				$row->getRelation('user')->visible(['nickname','realname','mobile','avatar']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }






    /**
     * 后台核销
     * @return string
     * @throws \think\Exception
     * @throws \think\db\exception\BindParamException
     * @throws \think\exception\DbException
     * @throws \think\exception\PDOException
     */
    public function verification($ids = ''){
        $param = $this->request->param();
        if($this->request->isPost()){
            try{
                if(isset($param['ids']))$ids = $param['ids'];
                $orderCode = \app\common\model\school\activity\order\OrderCode::where("id","=",$ids)->find();
                if(!$orderCode) throw new \Exception("核销码不存在！");
                //设置模拟资格
                $model = (new \app\common\model\school\activity\order\OrderCode);
                $model->verification($orderCode["code"],0,false,'admin',$this->auth->id,true);


            }catch (\Exception $e){
                $this->error($e->getMessage());
            }
            $this->success('核销成功!');
        }
        $row = $this->model->get($ids);
        $this->view->assign('vo', $row);
        return $this->view->fetch();
    }

}
