<?php

namespace app\admin\controller\school\classes;

use app\common\controller\Backend;

/**
 * 免费课黑名单
 *
 * @icon fa fa-circle-o
 */
class Blacklist extends Backend
{

    /**
     * Blacklist模型对象
     * @var \app\admin\model\school\classes\Blacklist
     */
    protected $model = null;
    protected $qSwitch = true;
    protected $qFields = ["user_id"];

    public function _initialize()
    {
        $this->model = new \app\admin\model\school\classes\Blacklist;
        parent::_initialize();

    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        $this->searchFields = ["id","user_id","user.nickname","user.realname","user.mobile"];

        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['user'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('user')->visible(['nickname','realname','mobile','avatar']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

}
