<?php

namespace app\admin\controller\school\classes;

use app\common\controller\Backend;

/**
 * 功能访问记录管理
 *
 * @icon fa fa-circle-o
 */
class Visit extends Backend
{

    /**
     * Visit模型对象
     * @var \app\admin\model\school\classes\Visit
     */
    protected $model = null;

    protected $qSwitch = true;
    protected $qFields = ["classes_lib_id","user_id","shop_id","classes_activity_id"];
    public function _initialize()
    {
        $this->model = new \app\admin\model\school\classes\Visit;
        parent::_initialize();

        $this->view->assign("statusList", $this->model->getStatusList());
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        $this->searchFields = ["id","classes_lib_id","helparticle.title","classes_activity_id","lib.title","user.nickname","user.realname","user.mobile","activity.title"];
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['lib','activity',"user","helparticle"])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('lib')->visible(['title','headimage']);
				$row->getRelation('activity')->visible(['title','headimage']);
                $row->getRelation('user')->visible(['nickname', 'realname', 'mobile', 'avatar']);
                $row->getRelation('helparticle')->visible(['title']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

}
