define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'school/classes/verification/index' + location.search,
                    add_url: 'school/classes/verification/add'+ location.search,
                    edit_url: 'school/classes/verification/edit'+ location.search,
                    del_url: 'school/classes/verification/del',
                    multi_url: 'school/classes/verification/multi',
                    import_url: 'school/classes/verification/import',
                    table: 'school_verification',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                fixedColumns: true,
                fixedRightNumber: 1,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'manystore_id', title: __('Manystore_id')},
                        {field: 'shop_id', title: __('Shop_id')},
                        {field: 'user_id', title: __('User_id')},

                        {field: 'classes_title', title: __('Classes_lib_ids'),visible:false, operate: false, formatter: Table.api.formatter.flag},

                        {field: 'classes_lib_ids', title: __('Classes_lib_ids'),visible:false, operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},


                        {field: 'status', title: __('Status'), searchList: {"1":__('Status 1'),"2":__('Status 2')}, formatter: Table.api.formatter.status},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'updatetime', title: __('Updatetime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'manystore.nickname', title: __('Manystore.nickname'), operate: 'LIKE'},
                        {field: 'manystore.avatar', title: __('Manystore.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'shop.name', title: __('Shop.name'), operate: 'LIKE'},
                        {field: 'shop.image', title: __('Shop.image'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'shop.address_city', title: __('Shop.address_city'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        {field: 'shop.province', title: __('Shop.province')},
                        {field: 'shop.city', title: __('Shop.city')},
                        {field: 'shop.district', title: __('Shop.district')},
                        {field: 'shop.address', title: __('Shop.address'), operate: 'LIKE'},
                        {field: 'shop.address_detail', title: __('Shop.address_detail'), operate: 'LIKE'},
                        {field: 'user.nickname', title: __('User.nickname'), operate: 'LIKE'},
                        {field: 'user.realname', title: __('User.realname'), operate: 'LIKE'},
                        {field: 'user.mobile', title: __('User.mobile'), operate: 'LIKE'},
                        {field: 'user.avatar', title: __('User.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'operate', title: __('Operate'), table: table , buttons: [
                                {
                                    name: 'manystore',
                                    text: __('查看机构'),
                                    title: __('查看机构'),
                                    classname: 'btn btn-dialog',
                                    icon: 'fa fa-home',
                                     dropdown : '更多',
                                    url: manystore_url,
                                    callback: function (data) {

                                    },
                                    // visible: function (row) {
                                    //     return row.classes_evaluate_id;
                                    // }
                                },

                            ], events: Table.api.events.operate, formatter: Table.api.formatter.operate},

                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {


                $(document).on('click', '.btn-changeuser', function (event) {
                    var url = $(this).attr('data-url');
                    if(!url) return false;
                    var title = $(this).attr('title');
                    var width = $(this).attr('data-width');
                    var height = $(this).attr('data-height');
                    // var ids = $(this).attr('data-id');
                    var area = [$(window).width() > 800 ? (width?width:'800px') : '95%', $(window).height() > 600 ? (height?height:'600px') : '95%'];
                    var options = {
                        shadeClose: false,
                        shade: [0.3, '#393D49'],
                        area: area,
                        callback:function(ret){//回调方法，需要在本页面Controller中增加方法监听且调用Fast.api.close(ret)传递结果;
                            Fast.api.close(ret);
                        }
                    };
                    Fast.api.open(url,title,options);
                });

                //老师必须是上面机构中的
                $("#c-classes_lib_ids").data("params", function (obj) {
                    //obj为SelectPage对象
                    return {custom: {shop_id: $("#c-shop_id").val()}};
                });
                //机构清除老师也要清除
                $("#c-shop_id").change(function () {
                    $("#c-classes_lib_ids").selectPageClear();
                });

                Form.api.bindevent($("form[role=form]"));
            }
        }
    };


    var manystore_url = function (row,dom) {
        return 'manystore/index/index?shop_id='+row.shop_id;
    }

    return Controller;
});
