define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'school/classes/order/order_detail/index' + location.search,
                    add_url: 'school/classes/order/order_detail/add',
                    edit_url: 'school/classes/order/order_detail/edit',
                    del_url: 'school/classes/order/order_detail/del',
                    multi_url: 'school/classes/order/order_detail/multi',
                    import_url: 'school/classes/order/order_detail/import',
                    table: 'school_classes_order_detail',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                         {field: 'feel', title: __('是否免费'), searchList: {"0":__('付费课程'),"1":__('免费课程')}, formatter: Table.api.formatter.normal},
                        {field: 'classes_num', title: __('Classes_num')},
                        {field: 'use_num', title: __('Use_num')},
                        {field: 'sub_num', title: __('Sub_num')},
                        {field: 'classes_order_id',visible:false, title: __('Classes_order_id')},
                        {field: 'manystore_id',visible:false, title: __('Manystore_id')},
                        {field: 'shop_id',visible:false, title: __('Shop_id')},
                        {field: 'user_id',visible:false, title: __('User_id')},
                        {field: 'classes_cate_ids',visible:false, title: __('Classes_cate_ids'), operate: 'LIKE'},
                        {field: 'classes_label_ids',visible:false, title: __('Classes_label_ids'), operate: 'LIKE'},
                        {field: 'self_label_tag', title: __('Self_label_tag'), operate: 'LIKE'},
                        {field: 'add_type',visible:false, title: __('Add_type'), searchList: {"1":__('Add_type 1'),"2":__('Add_type 2')}, formatter: Table.api.formatter.normal},
                        {field: 'add_id',visible:false, title: __('Add_id')},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'headimage', title: __('Headimage'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'images', title: __('Images'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.images},
                        {field: 'type', title: __('Type'), searchList: {"out":__('Type out'),"in":__('Type in')}, formatter: Table.api.formatter.normal},
                        {field: 'price', title: __('Price'), operate:'BETWEEN'},

                        {field: 'unit_price', title: __('Unit_price'), operate:'BETWEEN'},
                        {field: 'used_price', title: __('Used_price'), operate:'BETWEEN'},


                        {field: 'address_type', title: __('Address_type'), searchList: {"1":__('Address_type 1'),"2":__('Address_type 2')}, formatter: Table.api.formatter.normal},
                        {field: 'address_city', title: __('Address_city'), operate: 'LIKE'},
                        {field: 'province', title: __('Province')},
                        {field: 'city', title: __('City')},
                        {field: 'district', title: __('District')},
                        {field: 'address', title: __('Address'), operate: 'LIKE'},
                        {field: 'address_detail', title: __('Address_detail'), operate: 'LIKE'},
                        {field: 'longitude', title: __('Longitude'), operate: 'LIKE'},
                        {field: 'latitude', title: __('Latitude'), operate: 'LIKE'},
                        {field: 'classes_date_text', title: __('Classes_date_text'), operate: 'LIKE'},
                        {field: 'classes_time_text', title: __('Classes_time_text'), operate: 'LIKE'},
                        {field: 'virtual_num',visible:false, title: __('Virtual_num')},
                        // {field: 'sale', title: __('Sale')},

                        {field: 'underline_price', title: __('Underline_price'), operate:'BETWEEN'},
                        {field: 'virtual_collect',visible:false, title: __('Virtual_collect')},

                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'updatetime', title: __('Updatetime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        // {field: 'schoolclassesorder.order_no', title: __('Schoolclassesorder.order_no'), operate: 'LIKE'},
                        // {field: 'manystore.nickname', title: __('Manystore.nickname'), operate: 'LIKE'},
                        // {field: 'manystore.avatar', title: __('Manystore.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        // {field: 'manystoreshop.name', title: __('Manystoreshop.name'), operate: 'LIKE'},
                        // {field: 'manystoreshop.image', title: __('Manystoreshop.image'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        // {field: 'manystoreshop.address_city', title: __('Manystoreshop.address_city'), operate: 'LIKE'},
                        // {field: 'manystoreshop.province', title: __('Manystoreshop.province')},
                        // {field: 'manystoreshop.city', title: __('Manystoreshop.city')},
                        // {field: 'manystoreshop.district', title: __('Manystoreshop.district')},
                        // {field: 'manystoreshop.address', title: __('Manystoreshop.address'), operate: 'LIKE'},
                        // {field: 'manystoreshop.address_detail', title: __('Manystoreshop.address_detail'), operate: 'LIKE'},
                        // {field: 'user.nickname', title: __('User.nickname'), operate: 'LIKE'},
                        // {field: 'user.realname', title: __('User.realname'), operate: 'LIKE'},
                        // {field: 'user.mobile', title: __('User.mobile'), operate: 'LIKE'},
                        // {field: 'user.avatar', title: __('User.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        // {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        recyclebin: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    'dragsort_url': ''
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: 'school/classes/order/order_detail/recyclebin' + location.search,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'title', title: __('Title'), align: 'left'},
                        {
                            field: 'deletetime',
                            title: __('Deletetime'),
                            operate: 'RANGE',
                            addclass: 'datetimerange',
                            formatter: Table.api.formatter.datetime
                        },
                        {
                            field: 'operate',
                            width: '130px',
                            title: __('Operate'),
                            table: table,
                            events: Table.api.events.operate,
                            buttons: [
                                {
                                    name: 'Restore',
                                    text: __('Restore'),
                                    classname: 'btn btn-xs btn-info btn-ajax btn-restoreit',
                                    icon: 'fa fa-rotate-left',
                                    url: 'school/classes/order/order_detail/restore',
                                    refresh: true
                                },
                                {
                                    name: 'Destroy',
                                    text: __('Destroy'),
                                    classname: 'btn btn-xs btn-danger btn-ajax btn-destroyit',
                                    icon: 'fa fa-times',
                                    url: 'school/classes/order/order_detail/destroy',
                                    refresh: true
                                }
                            ],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});